;===========================================================================================
; Text_3.asm  GoAsm assembler
; Fonte et Texte en couleur
; Programm par AsmGges France
;===========================================================================================
; compile.bat:
; ..\..\bin\GoRC /r, res\text_3.rc
; ..\..\bin\GoAsm text_3.asm
; ..\..\bin\GoLink text_3.obj res\text_3.res user32.dll kernel32.dll
;===========================================================================================

; Inclusion des macros/quates/structures ncessaires au programme
; ----------------------------------------------------------------
  #include "..\..\inc\Windows.inc"
  #include "..\..\inc\all_api.inc"

; Macro couleur dans eax
  RGB(%red,%green,%blue) = mov eax,0     \
                           mov ah,%blue  \
                           shl eax,8     \
                           mov ah,%green \
                           mov al,%red   

  ID_FRANCE = 17

;===========================================================================================
; Dbut du code programme
; -----------------------
.code

start:
    ; Obtenir le handle du programme
    ; ------------------------------
    invoke GetModuleHandle,0
    mov [wc.hInstance],eax

    ; Chargement d'une icne
    ; ----------------------
    invoke LoadIcon,[wc.hInstance],ID_FRANCE
    mov [wc.hIcon],eax

    ; Chargement d'un curseur
    ; -----------------------
    invoke LoadCursor,0,IDC_ARROW
    mov [wc.hCursor],eax

    ; Obtenir la largeur en pixels de l'cran
    ; ---------------------------------------
    invoke GetSystemMetrics,SM_CXSCREEN
    sub eax,[WinW]
    shr eax,1
    mov [WinX],eax

    ; Obtenir la hauteur en pixels de l'cran
    ; ---------------------------------------
    invoke GetSystemMetrics,SM_CYSCREEN
    sub eax,[WinH]
    shr eax,1
    mov [WinY],eax

    ; Valider le choix de la structure WNDCLASS
    ; -----------------------------------------
    invoke RegisterClass,addr wc

    ; Cration de la fentre de l'application
    ; ---------------------------------------
    invoke CreateWindowEx,WS_EX_CLIENTEDGE,addr ClassName,addr Title,\
                          WS_OVERLAPPEDWINDOW+WS_VISIBLE,\
                          [WinX],[WinY],[WinW],[WinH],0,0,[wc.hInstance],0
    mov [hWnd],eax

    ; Affichage de la fentre
    ; -----------------------
    invoke ShowWindow,[hWnd],SW_SHOWDEFAULT

    ; Rafraichissement de la fentre
    ; ------------------------------
    invoke UpdateWindow,[hWnd]

 ;----------------------------------
 ; Boucle de traitement des messages
 ;----------------------------------
 MessageLoop:
    ; Rceptionne les messages
    ; ------------------------
    invoke GetMessage,addr msg,0,0,0
    or eax,eax
    jz >ExitProgram

    ; Traduit les touches d'entre clavier en messages
    ; ------------------------------------------------
    invoke TranslateMessage,addr msg

    ; Expdition des messages  la procdure Windows
    ; ---------------------------------------------
    invoke DispatchMessage,addr msg

    jmp <MessageLoop

 ExitProgram:
    ; Fermeture de l'application
    ; --------------------------
    invoke ExitProcess,[msg.wParam]

;===========================================================================================
; Procdure principale Windows
;-------------------------------------------------------------------------------------------
WindowProc frame @hWnd, @uMsg, @wParam, @lParam
    uses ebx,esi,edi

    cmp D[@uMsg],WM_CLOSE
    jne >.wmpaint
        ; Boite  message fin d'application
        ; ---------------------------------
        invoke MessageBox,[@hWnd],addr MsgEnd,addr ClassName,MB_OK+MB_ICONINFORMATION

        ; Demande la fin de l'application
        ; -------------------------------
        invoke PostQuitMessage,0
        jmp >>.exit

    .wmpaint:
    cmp D[@uMsg],WM_PAINT
    jne >>.defwindowproc
        ; Dbut criture/dessin
        ; ---------------------
        invoke BeginPaint,[@hWnd],addr ps

        ; Cration d'une fonte de caractres
        ; ----------------------------------
        invoke CreateFont,24,16,0,0,400,0,0,0,OEM_CHARSET,OUT_DEFAULT_PRECIS,\
                          CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH \
                          +FF_SCRIPT,addr NFont

        ; Choisit un objet suivant le contexte de dispositif hdc
        ; ------------------------------------------------------
        invoke SelectObject,[ps.hdc],eax
        mov [hFont],eax

        ; Fixer la couleur du texte
        ; -------------------------
        RGB(000,000,255)
        invoke SetTextColor,[ps.hdc],eax

        ; Fixer la couleur de fond du texte
        ; ---------------------------------
        RGB(255,000,000)
        invoke SetBkColor,[ps.hdc],eax

        ; Obtenir les coordonnes relatives de la fentre
        ; -----------------------------------------------
        invoke GetClientRect,[@hWnd],addr rect

        ; Ecriture dans la fentre
        ; ------------------------
        invoke DrawText,[ps.hdc],addr TxtString,-1,addr rect,\
                        DT_SINGLELINE+DT_CENTER+DT_VCENTER

        ; Choisit un objet suivant le contexte de dispositif hdc
        ; ------------------------------------------------------
        invoke SelectObject,[ps.hdc],[hFont]

        ; Fin criture/dessin
        ; -------------------
        invoke EndPaint,[@hWnd],eax
        jmp >.exit

    .defwindowproc:
        ; Traitement par dfaut des autres messages Windows
        ; ------------------------------------------------
        invoke DefWindowProc,[@hWnd],[@uMsg],[@wParam],[@lParam]
        ret

    .exit:
    mov eax,0
    ret
endf

;===========================================================================================
; Dfinitions des datas chaines / variables initialises ou non initialises / structures
; ------------------------------------------------------------------------------------------
.data

  Title     db ' Fonte et Texte en couleur ',0
  ClassName db ' AsmGges Win32',0
  MsgEnd    db ' GoAsm AsmGges France @2006  ',0
  TxtString db ' Fonte et Texte couleur ',0
  NFont     db 'script',0
  align 4

  WinX      dd 0
  WinY      dd 0
  WinW      dd 512
  WinH      dd 352

  hWnd      dd ?
  hFont     dd ?

  wc        WNDCLASS    < 0,addr WindowProc,0,0,NULL,NULL,NULL,\
                          COLOR_WINDOW+1,NULL,addr ClassName >
  ps        PAINTSTRUCT <>
  rect      RECT        <>
  msg       MSG         <>

;===========================================================================================
